<?php
/**
 * Created by PhpStorm.
 * User: Demolady
 * Date: 2019/5/28
 * Time: 19:05
 */
namespace kwy\baiduapi;
use kwy\baiduapi\common\Request;

class Position
{
    use Request;
    private $appkey;
    public function __construct($appkey="CBqitNh3LjcFeKs2OlMjGyxS"){

        $this->appkey=$appkey;
    }

    /**
     *
     * @abstract 获取最短路径的距离 单位米.每日调用次数限制
     * @param String $a_lat
     * @param String $a_lng
     * @param String $b_lat
     * @param String $b_lng
     */
    public function getRouteDistance($a_lat,$a_lng,$b_lat,$b_lng){
        $baiduak=$this->appkey;
        //获取 店铺地理位置经纬度
        $aposition=$a_lat.",".$a_lng;
        $bposition=$b_lat.",".$b_lng;
        $baiduapidirection="http://api.map.baidu.com/direction/v1?mode=walking&origin=".$aposition."&destination=".$bposition."&origin_region=杭州&destination_region=杭州&output=json&ak=".$baiduak;
        $directionjson=file_get_contents($baiduapidirection);
        $directionjsonobj=json_decode($directionjson);
        $distance=doubleval($directionjsonobj->result->routes[0]->distance);
        return $distance;
    }

    /**
     *
     * @abstract 通过经纬度 获取 地址信息
     * @param String $lat
     * @param String $lng
     */
    public function getAddressByLocation($lat,$lng){
        //地址转换
        $ak="CBqitNh3LjcFeKs2OlMjGyxS";
        $baiduapiurl="http://api.map.baidu.com/geocoder/v2/?ak=".$ak."&location=".$lat.",".$lng."&output=json&coordtype=gcj02ll";
        $addressjson = file_get_contents($baiduapiurl);
        $ret_arr=json_decode($addressjson,true);
        return $ret_arr;

    }

    /**
     *
     * @abstract 获取POI信息 默认小区类型
     * @param String $location 格式 "30.123,120.323"
     * @param String $type
     */
    public function getPOI($location,$type="小区"){
        $url='http://api.map.baidu.com/place/v2/search?ak='.$this->appkey.'&output=json&query='.$type.'&page_size=20&page_num=0&scope=2&location='.$location.'&radius=3000';
        if (strcmp($type, "小区")!=0){
            $url='http://api.map.baidu.com/place/v2/search?ak='.$this->appkey.'&output=json&query='.$type.'&page_size=20&page_num=0&scope=2&location='.$location.'&radius=3000';
        }
        if (strcmp($type, "餐饮")==0){
            $url='http://api.map.baidu.com/place/v2/search?ak='.$this->appkey.'&output=json&query='.$type.'&page_size=20&page_num=0&scope=2&location='.$location.'&radius=300';
        }
        $ret=$this->get($url);
        $retJsonArr=json_decode($ret,true);
        $results=$retJsonArr['results'];
        if (strcmp($type, "餐饮")==0){

        }else {
            foreach ($results as $k=>$v){
                if (strcmp($v['detail_info']['tag'], "房地产;住宅区")!=0){
                    unset($results[$k]);
                }
            }
        }

        //$results['test']=$ret;
        return $results;

    }

    /**
     * 坐标系转换
     */
    public function positionTransform($lat,$lng,$from='3',$to='5'){
        $url = 'http://api.map.baidu.com/geoconv/v1/?coords='.$lng.','.$lat.'&from='.$from.'&to='.$to.'&ak='.$this->appkey;
        $ret = $this->get($url);
        $retJsonArr = json_decode($ret,true);
        $res = ['lat'=>$retJsonArr['result'][0]['y'],'lng'=>$retJsonArr['result'][0]['x']];
        return $res;
    }
}